package Ightaria;

import java.awt.*;
import java.lang.Math;

import Globals.*;
import DrawTexts.*;
import CalculusAndVectors.*;




/** Class Population. 
    Typing such a long word was intolerant, so it 
    was shortcut to Pop.
*/
public class Pop {

    static double oVisualRange = 10000;  
    static double oVisualRangeNormalized;

    static SPad[] sPad = SPad.sPad;
    static SPad   SPa  = SPad.sPad[SPad.a_];


    static int hlL, hlLM = 20;           //How many hills in scenario.
    //Hill   grHill;
    static Scene grHill;
    // Vector hills = new Vector(20);
    static Hill[] hills = new Hill[20];  //do1: bad: 
                                  //will need garbage collector
                                  //to dispose this never used objects.

    //For individual hill:
    static int iMeasuredHill = 0;


    //Scene
    //int scL, scLM;                //How many hills are observed at given position.
    //Hill[] scene = new Hill[10];  //do2 all. lim. protection.

    //Help and work variables:
    static double wd, wd2;
    static final double PI = Math.PI;
    static double wTheta, wPhi;



    //================================================================
    //  S u p p l y   a n d   r e l e a s e   r e s o u r c e s
    //----------------------------------------------------------------
    /** This resource must be supplied after Population
        has been initialized and Scratch Pads Graphics was supplied */
    static public void supplyGraphics() {
        GS.con("Supplying Graphics to Population ... ");
        grHill.supplyGraphics();
        for(int i=1; i<hlL; i++) {
            hills[i].supplyGraphics();
        } 
    }
    static public void releaseGraphics() {
           grHill.releaseGraphics();
           for(int i=1; i<hlL; i++) {
               hills[i].releaseGraphics();
           } 
    }
    //----------------------------------------------------------------
    //  S u p p l y   a n d   r e l e a s e   r e s o u r c e s
    //================================================================









    /**<pre>**********************************************************

       Populate HomeFold.
       The programmer acts here as a real gardener of HomeFold World:
       plants valleys and hills, towns ans stars.
       HFold must be already initialized.
       This method happens only once only at application startup.

    ******************************************************************</pre>*/
    static public void initiate() {

        int i;
        grHill = new Scene(
                      sPad[SPad.a_],
                      sPad[SPad.C_],
                      sPad[SPad.C_].xL, 
                      sPad[SPad.C_].yL,
                      sPad[SPad.C_].xL/2, 
                      sPad[SPad.C_].yL/2,
                      Hill.funTerrain,
                      false  //addFunctionToTerrainFunction
        );

        for(i=1; i<10; i++) {
            hills[i] = new Hill(
                  sPad[SPad.a_],
                  sPad[SPad.C_],
                  sPad[SPad.C_].xL, 
                  sPad[SPad.C_].yL,
                  sPad[SPad.C_].xL/2, 
                  sPad[SPad.C_].yL/2,
                  Hill.funGaussBell,
                  true  //addFunctionToTerrainFunction
            );
            hills[i].iXinHillsFamily = i;
            if( i<6 ) hills[i].canBeAStar = true;
       }
   

       //Home Village:
       hills[1].name = "Villeya";
       hills[1].loc = new DVector( 200.,500.,HFold.hfRadius );
       DVector.FixUnitV( hills[1].loc );
       hills[1].startUpDistance = HFold.v.PsyTauDefined(hills[1].loc).t * HFold.hfRadius; 
       hills[1].StarHalfPeriod=27;
       hills[1].SatelliteColorPhase1 = new Color( 150<<16 | 150<<8 | 240 );
       hills[1].SatelliteColorPhase2 = new Color( 150<<16 | 240<<8 | 150 );
       hills[1].starXRange        = 2;
       hills[1].starSizeAmplitude = 3;
       hills[1].starSizeMin       = 2;



       //Closest neighbour.
       wTheta = PI/3.; //Counted from axis z.
       wd  = Math.cos(wTheta);
       wd2 = Math.sin(wTheta);
       hills[2].loc = new DVector( 0., wd2, wd );
       hills[2].name = "Azoruus";
       //EDistance:
       hills[2].startUpDistance = HFold.hfRadius * Math.tan(wTheta);


       //Red Giant. Negative dAzi/dPath.
       hills[3].name = "Giphos";
       wTheta = .75*PI;
       wPhi   = PI/4.;
       wd     = Math.cos(wPhi);
       wd2    = Math.sin( wTheta );
       hills[3].loc = new DVector( wd*wd2,wd*wd2,Math.cos(wTheta ) ); 
       hills[3].SatelliteColorPhase1 = new Color( 255<<16 | 100<<8 | 100 );
       hills[3].SatelliteColorPhase2 = new Color( 255<<16 | 255<<8 | 100 );
       hills[3].StarHalfPeriod=10;
       hills[3].starXRange        = 3;
       hills[3].starSizeAmplitude = 5;
       hills[3].starSizeMin       = 1;
       hills[3].startUpDistance = HFold.hfRadius * Math.tan(wTheta);


       //Finished creation:
       hlL=4;

       //Auxiliary work:
       oVisualRangeNormalized = oVisualRange/HFold.hfRadius;


    }  //The end of intialize...








   //********************************************************************

   /** This method dynamically populates hills' parameters at run-time */
   static public void PopulateScene() {

   //********************************************************************

          grHill.oFp = HFold.oFp;

          for(int i=1; i<hlL;   i++) {

              DVector v = HFold.v.PsyTauDefined(hills[i].loc);  //do2 slow:
              double p=v.p;
              double t=v.t;
              double sphDist = t * HFold.hfRadius;

              hills[i].hVp       = p;  //do1 possibly duplicate notation.
              hills[i].oDistance = sphDist;
              hills[i].oTau      = t;
              hills[i].oFp       = HFold.oFp; //Really dFp

              //This is good:
              //  1. vFp is master.
              //  2. oc  is master. v,p are from master.
              double hFp = Vec.fixAzi(p + HFold.vFp); 

              hills[i].hFp = hFp;
              double hOp = Vec.fixAzi(hFp - HFold.oFp);
              hills[i].hOp = hOp;           //Really hDp

              hills[i].oFrontDistance = sphDist * Math.cos(hOp);
              
              
              hills[i].visible         = false;
              hills[i].measureTooClose = false;
              hills[i].drawAsCloseOrFarStar = Hill.DRAW_AS_NOT_STAR;
              if(sphDist > oVisualRange ) {
                 hills[i].inSceneRange   = false;
                 if( Math.abs(hOp) < Vec.PI2 ) { //In front half sphere before observer
                     if( hills[i].canBeAStar ) { 
                         hills[i].visible = true;
                         hills[i].drawAsCloseOrFarStar = Hill.DRAW_AS_CLOSE_STAR;
                     }
                 }else{
                     if( hills[i].canBeAStar ) { 
                         hills[i].visible = true;
                         hills[i].drawAsCloseOrFarStar = Hill.DRAW_AS_FAR_STAR;
                     }
                 }
              } else {
                hills[i].inSceneRange = true;
                //do1 Trully, this must do something with angle of view:
                //    Currently about PI/4:
                if( Math.abs(hOp) < Vec.PI2 ) { 
                    //In front half sphere before observer
                    //hills[i].inSceneRange = true;
                    hills[i].visible      = true;
                    if( sphDist / HFold.hfRadius < 1.e-100 ) {
                        hills[i].measureTooClose = true;
                    }
                }else{
                    if( hills[i].canBeAStar ) { 
                        //This involves a portion of magic ...
                        //Close hill should be not a point-oposite-star, 
                        //but some exendend object ... But, this 
                        //program still display it as a star:
                        hills[i].visible = true;
                        hills[i].drawAsCloseOrFarStar = Hill.DRAW_AS_FAR_STAR;
                    }
                }
              }                
          }  
  }  






/** Must be called from Path Tracker thread 
    to print displayAngleMiner correctly. 
*/
static public void cancelAllMeasurements() {
       //Cancel all measurment work:
       
       //Cancel derivator:
       HFold.toggleMeasurement(false);
       if( iMeasuredHill !=0 ) {
           hills[iMeasuredHill].doMeasure(false); 

           //Clear windows:
           HFold.runAngleminerAnDerivator();
           //displayAngleMiner();

       }
       HFold.doPaintScratchMaps = true;
}


/** Must be called from Path Tracker thread 
    to print displayAngleMiner correctly. 
*/
static public void toggleMeasurementedHill() {
       cancelAllMeasurements();
       iMeasuredHill = (iMeasuredHill + 1) % hlL; 
       if( iMeasuredHill !=0 ) {
           hills[iMeasuredHill].doMeasure(true); 
           HFold.toggleMeasurement(true);
       }
       HFold.runAngleminerAnDerivator();
       //displayAngleMiner();
}




static public void displayAngleMiner() {

       if( 0 == iMeasuredHill ) {
           HFold.spFDigits.wrc("ANGLEMINER  is turned off");
           SPa.wrc("NEIGHBOUR HILL  not selected" );
           return;
       }

       //do1b Patch. Handle control which competes for this
       //Scratch Pad: 
       if( Scenario.TXT_QUICK_HELP == Scenario.txt_Current ) {
           //remove Quick Help:
           Scenario.setText(Scenario.TXT_NOTHING);
       }

       Hill measH = hills[iMeasuredHill];
       //do1 correct sign:
       double measAzi  = measH.twin_hVp(false);

       if( measH.inSceneRange ) {

           HFold.spFDigits.wrc ("ANGLEMINER");
           HFold.spFDigits.wr  ("Hill: " + measH.measuredName() );
           HFold.spFDigits.wr  ("Azi=" + measAzi + " (Ves.)");

           SPa.wrc("NEIGHBOUR HILL    " +  measH.measuredName() );

       }else{

           HFold.spFDigits.wrc ("ANGLEMINER");
           HFold.spFDigits.wr  ("Star: " + measH.measuredName() );
           HFold.spFDigits.wr  ("Azi=" + measAzi + " (Ves.)");

           SPa.wrc("REMOTE HILL    " +  measH.measuredName() );
           if( Scenario.levHFConqueror <= Scenario.level || Scenario.cheatEnabled ) {
               SPa.wr ("Too distant ... cheatsuring ... ");
           }else{
               SPa.wr ("Seems too distant to measure ...");
               return;
           }    
       }

       SPa.wr ("F r o m   D r i v e r:");
       SPa.wr ("distance=" + measH.oDistance);
       SPa.wr ("Azi=" + measH.hOp);
       double oHx = - measH.oDistance * Math.cos(measH.hFp);
       double oHy = + measH.oDistance * Math.sin(measH.hFp);
       SPa.wr ("x=" + oHx);
       SPa.wr ("y=" + oHy);      
     
       //do2. Need azi for driver to be displayed.
       //NEIGHBOUR:
       SPa.wr ("F r o m   S t a r t   P o i n t:");
       SPa.wr ("Azi=" + measH.hFp);

       //do1 this is proliferated code:
       //double hOOy =  measH.oDistance * Math.cos(measH.hOp);
       //double hOOx = -measH.oDistance * Math.sin(measH.hOp);
       //hFFx = Terrain.oFFMx + hOOx * Math.cos(HFold.oFp) - hOOy * Math.sin(oFp);
       //hFFy = Terrain.oFFMy + hOOx * Math.sin(HFold.oFp) + hOOy * Math.cos(oFp);
       //Wrong: double hFFx = Terrain.oFFMx - measH.oDistance * Math.cos(measH.hFp);
       //       double hFFy = Terrain.oFFMy + measH.oDistance * Math.sin(measH.hFp);
       double hFFx = HFold.flatX + oHx;
       double hFFy = HFold.flatY + oHy;
       double flatDistance = Math.sqrt(hFFx*hFFx + hFFy*hFFy);

       SPa.wr ("distance=" + flatDistance);      
       SPa.wr ("x=" + hFFx);
       SPa.wr ("y=" + hFFy);      

       if( Scenario.levHFConqueror <= Scenario.level || Scenario.cheatEnabled ) {
           SPa.wr( "Tau=" + measH.oTau);
       }
       
} //void displayAngleMiner





} //Class end.
